import { Injectable, ɵɵdefineInjectable, Component, ChangeDetectorRef, ViewChild, Input, NgModule } from '@angular/core';
import { Subject, Subscription } from 'rxjs';
import * as moment_ from 'moment';
import { CommonModule } from '@angular/common';
import { DragDropModule } from '@angular/cdk/drag-drop';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTimeSchedulerService {
    constructor() {
        this.item = new Subject();
        this.itemAdd = new Subject();
        this.itemId = new Subject();
        this.sectionAdd = new Subject();
        this.section = new Subject();
        this.sectionId = new Subject();
        this.refreshView = new Subject();
    }
    /**
     * @param {?} item
     * @return {?}
     */
    itemPush(item) {
        this.itemAdd.next(item);
    }
    /**
     * @return {?}
     */
    itemPop() {
        this.item.next();
    }
    /**
     * @param {?} id
     * @return {?}
     */
    itemRemove(id) {
        this.itemId.next(id);
    }
    /**
     * @param {?} section
     * @return {?}
     */
    sectionPush(section) {
        this.sectionAdd.next(section);
    }
    /**
     * @return {?}
     */
    sectionPop() {
        this.section.next();
    }
    /**
     * @param {?} id
     * @return {?}
     */
    sectionRemove(id) {
        this.sectionId.next(id);
    }
    /**
     * @return {?}
     */
    refresh() {
        this.refreshView.next();
    }
}
NgxTimeSchedulerService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxTimeSchedulerService.ctorParameters = () => [];
/** @nocollapse */ NgxTimeSchedulerService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxTimeSchedulerService_Factory() { return new NgxTimeSchedulerService(); }, token: NgxTimeSchedulerService, providedIn: "root" });
if (false) {
    /** @type {?} */
    NgxTimeSchedulerService.prototype.item;
    /** @type {?} */
    NgxTimeSchedulerService.prototype.itemAdd;
    /** @type {?} */
    NgxTimeSchedulerService.prototype.itemId;
    /** @type {?} */
    NgxTimeSchedulerService.prototype.sectionAdd;
    /** @type {?} */
    NgxTimeSchedulerService.prototype.section;
    /** @type {?} */
    NgxTimeSchedulerService.prototype.sectionId;
    /** @type {?} */
    NgxTimeSchedulerService.prototype.refreshView;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Period {
}
if (false) {
    /** @type {?} */
    Period.prototype.name;
    /** @type {?} */
    Period.prototype.classes;
    /** @type {?} */
    Period.prototype.timeFramePeriod;
    /** @type {?} */
    Period.prototype.timeFrameOverall;
    /** @type {?} */
    Period.prototype.timeFrameHeaders;
}
class Item {
}
if (false) {
    /** @type {?} */
    Item.prototype.id;
    /** @type {?} */
    Item.prototype.name;
    /** @type {?} */
    Item.prototype.start;
    /** @type {?} */
    Item.prototype.end;
    /** @type {?} */
    Item.prototype.classes;
    /** @type {?} */
    Item.prototype.sectionID;
}
class Section {
}
if (false) {
    /** @type {?} */
    Section.prototype.id;
    /** @type {?} */
    Section.prototype.name;
}
class Text {
    constructor() {
        this.NextButton = 'Next';
        this.PrevButton = 'Prev';
        this.TodayButton = 'Today';
        this.GotoButton = 'Go to';
        this.SectionTitle = 'Section';
    }
}
if (false) {
    /** @type {?} */
    Text.prototype.NextButton;
    /** @type {?} */
    Text.prototype.PrevButton;
    /** @type {?} */
    Text.prototype.TodayButton;
    /** @type {?} */
    Text.prototype.GotoButton;
    /** @type {?} */
    Text.prototype.SectionTitle;
}
class Events {
}
if (false) {
    /** @type {?} */
    Events.prototype.ItemDropped;
    /** @type {?} */
    Events.prototype.ItemClicked;
    /** @type {?} */
    Events.prototype.ItemContextMenu;
    /** @type {?} */
    Events.prototype.SectionClickEvent;
    /** @type {?} */
    Events.prototype.SectionContextMenuEvent;
}
class SectionItem {
    constructor() {
        this.itemMetas = new Array();
    }
}
if (false) {
    /** @type {?} */
    SectionItem.prototype.section;
    /** @type {?} */
    SectionItem.prototype.minRowHeight;
    /** @type {?} */
    SectionItem.prototype.itemMetas;
}
class ItemMeta {
    constructor() {
        this.cssTop = 0;
        this.cssLeft = 0;
        this.cssWidth = 0;
    }
}
if (false) {
    /** @type {?} */
    ItemMeta.prototype.item;
    /** @type {?} */
    ItemMeta.prototype.isStart;
    /** @type {?} */
    ItemMeta.prototype.isEnd;
    /** @type {?} */
    ItemMeta.prototype.cssTop;
    /** @type {?} */
    ItemMeta.prototype.cssLeft;
    /** @type {?} */
    ItemMeta.prototype.cssWidth;
}
class Header {
    constructor() {
        this.headerDetails = new Array();
    }
}
if (false) {
    /** @type {?} */
    Header.prototype.headerDetails;
}
class HeaderDetails {
}
if (false) {
    /** @type {?} */
    HeaderDetails.prototype.name;
    /** @type {?} */
    HeaderDetails.prototype.colspan;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const moment = moment_;
class NgxTimeSchedulerComponent {
    /**
     * @param {?} changeDetector
     * @param {?} service
     */
    constructor(changeDetector, service) {
        this.changeDetector = changeDetector;
        this.service = service;
        this.currentTimeFormat = 'DD-MMM-YYYY HH:mm';
        this.showCurrentTime = true;
        this.showGoto = true;
        this.showToday = true;
        this.allowDragging = false;
        // @Input() allowResizing = false;
        this.showBusinessDayOnly = false;
        this.headerFormat = 'Do MMM YYYY';
        this.minRowHeight = 40;
        this.maxHeight = null;
        this.text = new Text();
        this.events = new Events();
        this.start = moment().startOf('day');
        this.end = moment().endOf('day');
        this.showGotoModal = false;
        this.currentTimeVisibility = 'visible';
        this.ShowCurrentTimeHandle = null;
        this.SectionLeftMeasure = '0';
        this.currentPeriodMinuteDiff = 0;
        this.subscription = new Subscription();
        this.showCurrentTimeIndicator = (/**
         * @return {?}
         */
        () => {
            if (this.ShowCurrentTimeHandle) {
                clearTimeout(this.ShowCurrentTimeHandle);
            }
            /** @type {?} */
            const currentTime = moment();
            if (currentTime >= this.start && currentTime <= this.end) {
                this.currentTimeVisibility = 'visible';
                this.currentTimeIndicatorPosition = ((Math.abs(this.start.diff(currentTime, 'minutes')) / this.currentPeriodMinuteDiff) * 100) + '%';
                this.currentTimeTitle = currentTime.format(this.currentTimeFormat);
            }
            else {
                this.currentTimeVisibility = 'hidden';
            }
            this.ShowCurrentTimeHandle = setTimeout(this.showCurrentTimeIndicator, 30000);
        });
    }
    /**
     * @param {?} elementRef
     * @return {?}
     */
    set SectionTd(elementRef) {
        this.SectionLeftMeasure = elementRef.nativeElement.clientWidth + 'px';
        this.changeDetector.detectChanges();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.setSectionsInSectionItems();
        this.changePeriod(this.periods[0]);
        this.itemPush();
        this.itemPop();
        this.itemRemove();
        this.sectionPush();
        this.sectionPop();
        this.sectionRemove();
        this.refresh();
    }
    /**
     * @return {?}
     */
    refreshView() {
        this.setSectionsInSectionItems();
        this.changePeriod(this.currentPeriod);
    }
    /**
     * @param {?} index
     * @param {?} item
     * @return {?}
     */
    trackByFn(index, item) {
        return index;
    }
    /**
     * @return {?}
     */
    setSectionsInSectionItems() {
        this.sectionItems = new Array();
        this.sections.forEach((/**
         * @param {?} section
         * @return {?}
         */
        section => {
            /** @type {?} */
            const perSectionItem = new SectionItem();
            perSectionItem.section = section;
            perSectionItem.minRowHeight = this.minRowHeight;
            this.sectionItems.push(perSectionItem);
        }));
    }
    /**
     * @return {?}
     */
    setItemsInSectionItems() {
        /** @type {?} */
        const itemMetas = new Array();
        this.sectionItems.forEach((/**
         * @param {?} ele
         * @return {?}
         */
        ele => {
            ele.itemMetas = new Array();
            ele.minRowHeight = this.minRowHeight;
            this.items.filter((/**
             * @param {?} i
             * @return {?}
             */
            i => {
                /** @type {?} */
                let itemMeta = new ItemMeta();
                if (i.sectionID === ele.section.id) {
                    itemMeta.item = i;
                    if (itemMeta.item.start <= this.end && itemMeta.item.end >= this.start) {
                        itemMeta = this.itemMetaCal(itemMeta);
                        ele.itemMetas.push(itemMeta);
                        itemMetas.push(itemMeta);
                    }
                }
            }));
        }));
        /** @type {?} */
        const sortedItems = itemMetas.reduce((/**
         * @param {?} sortItems
         * @param {?} itemMeta
         * @return {?}
         */
        (sortItems, itemMeta) => {
            /** @type {?} */
            const index = this.sectionItems.findIndex((/**
             * @param {?} sectionItem
             * @return {?}
             */
            sectionItem => sectionItem.section.id === itemMeta.item.sectionID));
            if (!sortItems[index]) {
                sortItems[index] = [];
            }
            sortItems[index].push(itemMeta);
            return sortItems;
        }), {});
        this.calCssTop(sortedItems);
    }
    /**
     * @param {?} itemMeta
     * @return {?}
     */
    itemMetaCal(itemMeta) {
        /** @type {?} */
        const foundStart = moment.max(itemMeta.item.start, this.start);
        /** @type {?} */
        const foundEnd = moment.min(itemMeta.item.end, this.end);
        /** @type {?} */
        let widthMinuteDiff = Math.abs(foundStart.diff(foundEnd, 'minutes'));
        /** @type {?} */
        let leftMinuteDiff = foundStart.diff(this.start, 'minutes');
        if (this.showBusinessDayOnly) {
            widthMinuteDiff -= (this.getNumberOfWeekendDays(moment(foundStart), moment(foundEnd)) * this.currentPeriod.timeFramePeriod);
            leftMinuteDiff -= (this.getNumberOfWeekendDays(moment(this.start), moment(foundStart)) * this.currentPeriod.timeFramePeriod);
        }
        itemMeta.cssLeft = (leftMinuteDiff / this.currentPeriodMinuteDiff) * 100;
        itemMeta.cssWidth = (widthMinuteDiff / this.currentPeriodMinuteDiff) * 100;
        if (itemMeta.item.start >= this.start) {
            itemMeta.isStart = true;
        }
        if (itemMeta.item.end <= this.end) {
            itemMeta.isEnd = true;
        }
        return itemMeta;
    }
    /**
     * @param {?} sortedItems
     * @return {?}
     */
    calCssTop(sortedItems) {
        for (const prop of Object.keys(sortedItems)) {
            for (let i = 0; i < sortedItems[prop].length; i++) {
                /** @type {?} */
                let elemBottom;
                /** @type {?} */
                const elem = sortedItems[prop][i];
                for (let prev = 0; prev < i; prev++) {
                    /** @type {?} */
                    const prevElem = sortedItems[prop][prev];
                    /** @type {?} */
                    const prevElemBottom = prevElem.cssTop + this.minRowHeight;
                    elemBottom = elem.cssTop + this.minRowHeight;
                    if (((prevElem.item.start <= elem.item.start && elem.item.start <= prevElem.item.end) ||
                        (prevElem.item.start <= elem.item.end && elem.item.end <= prevElem.item.end) ||
                        (prevElem.item.start >= elem.item.start && elem.item.end >= prevElem.item.end)) && ((prevElem.cssTop <= elem.cssTop && elem.cssTop <= prevElemBottom) ||
                        (prevElem.cssTop <= elemBottom && elemBottom <= prevElemBottom))) {
                        elem.cssTop = prevElemBottom + 1;
                    }
                }
                elemBottom = elem.cssTop + this.minRowHeight + 1;
                if (this.sectionItems[Number(prop)] && elemBottom > this.sectionItems[Number(prop)].minRowHeight) {
                    this.sectionItems[Number(prop)].minRowHeight = elemBottom;
                }
            }
        }
    }
    /**
     * @param {?} period
     * @return {?}
     */
    changePeriod(period) {
        this.currentPeriod = period;
        /** @type {?} */
        const _start = this.start;
        this.end = moment(_start).add(this.currentPeriod.timeFrameOverall, 'minutes').endOf('day');
        this.currentPeriodMinuteDiff = Math.abs(this.start.diff(this.end, 'minutes'));
        if (this.showBusinessDayOnly) {
            this.currentPeriodMinuteDiff -=
                (this.getNumberOfWeekendDays(moment(this.start), moment(this.end)) * this.currentPeriod.timeFramePeriod);
        }
        this.header = new Array();
        this.currentPeriod.timeFrameHeaders.forEach((/**
         * @param {?} ele
         * @return {?}
         */
        ele => {
            this.header.push(this.getDatesBetweenTwoDates(ele));
        }));
        this.setItemsInSectionItems();
        this.showCurrentTimeIndicator();
    }
    /**
     * @return {?}
     */
    gotoToday() {
        this.start = moment().startOf('day');
        this.changePeriod(this.currentPeriod);
    }
    /**
     * @return {?}
     */
    nextPeriod() {
        this.start.add(this.currentPeriod.timeFrameOverall, 'minutes');
        this.changePeriod(this.currentPeriod);
    }
    /**
     * @return {?}
     */
    previousPeriod() {
        this.start.subtract(this.currentPeriod.timeFrameOverall, 'minutes');
        this.changePeriod(this.currentPeriod);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    gotoDate(event) {
        this.showGotoModal = false;
        this.start = moment(event).startOf('day');
        this.changePeriod(this.currentPeriod);
    }
    /**
     * @param {?} format
     * @return {?}
     */
    getDatesBetweenTwoDates(format) {
        /** @type {?} */
        const now = moment(this.start);
        /** @type {?} */
        const dates = new Header();
        /** @type {?} */
        let prev;
        /** @type {?} */
        let colspan = 0;
        while (now.isBefore(this.end) || now.isSame(this.end)) {
            if (!this.showBusinessDayOnly || (now.day() !== 0 && now.day() !== 6)) {
                /** @type {?} */
                const headerDetails = new HeaderDetails();
                headerDetails.name = now.format(format);
                if (prev && prev !== headerDetails.name) {
                    colspan = 1;
                }
                else {
                    colspan++;
                    dates.headerDetails.pop();
                }
                prev = headerDetails.name;
                headerDetails.colspan = colspan;
                dates.headerDetails.push(headerDetails);
            }
            now.add(this.currentPeriod.timeFramePeriod, 'minutes');
        }
        return dates;
    }
    /**
     * @param {?} startDate
     * @param {?} endDate
     * @return {?}
     */
    getNumberOfWeekendDays(startDate, endDate) {
        /** @type {?} */
        let count = 0;
        while (startDate.isBefore(endDate) || startDate.isSame(endDate)) {
            if ((startDate.day() === 0 || startDate.day() === 6)) {
                count++;
            }
            startDate.add(this.currentPeriod.timeFramePeriod, 'minutes');
        }
        return count;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    drop(event) {
        event.item.data.sectionID = event.container.data.id;
        this.refreshView();
        this.events.ItemDropped(event.item.data);
    }
    /**
     * @return {?}
     */
    itemPush() {
        this.subscription.add(this.service.itemAdd.asObservable().subscribe((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            this.items.push(item);
            this.refreshView();
        })));
    }
    /**
     * @return {?}
     */
    itemPop() {
        this.subscription.add(this.service.item.asObservable().subscribe((/**
         * @return {?}
         */
        () => {
            this.items.pop();
            this.refreshView();
        })));
    }
    /**
     * @return {?}
     */
    itemRemove() {
        this.subscription.add(this.service.itemId.asObservable().subscribe((/**
         * @param {?} itemId
         * @return {?}
         */
        (itemId) => {
            this.items.splice(this.items.findIndex((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                return item.id === itemId;
            })), 1);
            this.refreshView();
        })));
    }
    /**
     * @return {?}
     */
    sectionPush() {
        this.subscription.add(this.service.sectionAdd.asObservable().subscribe((/**
         * @param {?} section
         * @return {?}
         */
        (section) => {
            console.log(section);
            this.sections.push(section);
            this.refreshView();
        })));
    }
    /**
     * @return {?}
     */
    sectionPop() {
        this.subscription.add(this.service.section.asObservable().subscribe((/**
         * @return {?}
         */
        () => {
            this.sections.pop();
            this.refreshView();
        })));
    }
    /**
     * @return {?}
     */
    sectionRemove() {
        this.subscription.add(this.service.sectionId.asObservable().subscribe((/**
         * @param {?} sectionId
         * @return {?}
         */
        (sectionId) => {
            this.sections.splice(this.sections.findIndex((/**
             * @param {?} section
             * @return {?}
             */
            (section) => {
                return section.id === sectionId;
            })), 1);
            this.refreshView();
        })));
    }
    /**
     * @return {?}
     */
    refresh() {
        this.subscription.add(this.service.refreshView.asObservable().subscribe((/**
         * @return {?}
         */
        () => {
            this.refreshView();
        })));
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
}
NgxTimeSchedulerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-ts[items][periods][sections]',
                template: "<div class=\"time-sch-wrapper\" [style.height]=\"maxHeight\">\n  <div class=\"time-sch-header-wrapper mb-1\">\n    <div class=\"time-sch-period-container\">\n      <button class=\"btn\"\n              *ngFor=\"let period of periods\"\n              [ngClass]=\"period.classes\"\n              (click)=\"changePeriod(period)\"\n      >\n        {{period.name}}\n      </button>\n    </div>\n\n    <div class=\"time-sch-time-container\">\n      <button class=\"btn\" *ngIf=\"showGoto\" (click)=\"showGotoModal = !showGotoModal\">{{text.GotoButton}}</button>\n      <div class=\"goto-modal\" *ngIf=\"showGotoModal\">\n        <label>\n          <input type=\"date\" (change)=\"gotoDate($event.target.value)\">\n        </label>\n      </div>\n\n      <button class=\"btn\" *ngIf=\"showToday\" (click)=\"gotoToday()\">{{text.TodayButton}}</button>\n      <button class=\"btn\" (click)=\"previousPeriod()\">{{text.PrevButton}}</button>\n      <button class=\"btn\" (click)=\"nextPeriod()\">{{text.NextButton}}</button>\n    </div>\n\n    <h3 class=\"text-center m-0\">\n      {{ start.format(headerFormat) + ' - ' + end.format(headerFormat)}}\n    </h3>\n  </div>\n\n  <div class=\"time-sch-table-wrapper\">\n    <table class=\"time-sch-table\">\n      <tr *ngFor=\"let timeFrameHeader of header; let i = index; trackBy: trackByFn\">\n\n        <td class=\"time-sch-section text-center\" *ngIf=\"i === 0\" [rowSpan]=\"periods.length\">\n          {{text.SectionTitle}}\n        </td>\n\n        <td class=\"text-center\"\n            *ngFor=\"let dateTime of timeFrameHeader.headerDetails; trackBy: trackByFn\"\n            [colSpan]=\"dateTime.colspan\"\n        >\n          {{dateTime.name}}\n        </td>\n\n      </tr>\n    </table>\n\n    <div class=\"time-sch-content-wrap\">\n      <table class=\"time-sch-table\">\n        <tr *ngFor=\"let sectionItem of sectionItems; trackBy: trackByFn\"\n            [style.height]=\"sectionItem.minRowHeight + 'px'\">\n          <td class=\"time-sch-section text-center\" #sectionTd\n              (click)=\"events.SectionClickEvent ? events.SectionClickEvent(sectionItem.section) : false\"\n              (contextmenu)=\"events.SectionContextMenuEvent ? events.SectionContextMenuEvent(sectionItem.section, $event) : false\"\n              [style.cursor]=\"events.SectionClickEvent ? 'pointer' : ''\"\n          >\n            {{sectionItem.section.name}}\n          </td>\n\n          <td *ngFor=\"let td of header[header.length - 1].headerDetails; trackBy: trackByFn\"></td>\n        </tr>\n      </table>\n\n      <div class=\"time-sch-section-wrapper\" [style.left]=\"SectionLeftMeasure\" cdkDropListGroup>\n        <div class=\"time-sch-section-container\"\n             cdkDropList\n             cdkDropListSortingDisabled\n             [cdkDropListData]=\"sectionItem.section\"\n             (cdkDropListDropped)=\"drop($event)\"\n             *ngFor=\"let sectionItem of sectionItems; trackBy: trackByFn\"\n             [style.height]=\"sectionItem.minRowHeight + 'px'\"\n        >\n          <div class=\"time-sch-item\"\n               cdkDrag\n               cdkDragLockAxis=\"y\"\n               cdkDragBoundary=\".time-sch-section-wrapper\"\n               [cdkDragData]=\"itemMeta.item\"\n               [cdkDragDisabled]=\"!allowDragging\"\n               *ngFor=\"let itemMeta of sectionItem.itemMetas\"\n               [ngClass]=\"itemMeta.item.classes\"\n               (click)=\"events.ItemClicked ? events.ItemClicked(itemMeta.item) : false\"\n               (contextmenu)=\"events.ItemContextMenu ? events.ItemContextMenu(itemMeta.item, $event) : false\"\n               [style.height]=\"minRowHeight + 'px'\"\n               [style.top]=\"itemMeta.cssTop + 'px'\"\n               [style.left]=\"itemMeta.cssLeft + '%'\"\n               [style.width]=\"itemMeta.cssWidth + '%'\"\n          >\n            <div class=\"item-drag-placeholder\"\n                 *cdkDragPlaceholder\n                 [style.height]=\"(minRowHeight - 6) + 'px'\"\n                 [style.left]=\"itemMeta.cssLeft + '%'\"\n                 [style.width]=\"'calc('+ itemMeta.cssWidth + '% - 6px)'\"\n            ></div>\n            <div class=\"time-sch-item-start\" *ngIf=\"itemMeta.isStart\"></div>\n            <div class=\"time-sch-item-content\">\n              {{itemMeta.item.name}}\n            </div>\n            <div class=\"time-sch-item-end\" *ngIf=\"itemMeta.isEnd\"></div>\n          </div>\n        </div>\n\n        <div class=\"time-sch-current-time\"\n             *ngIf=\"showCurrentTime\"\n             [title]=\"currentTimeTitle\"\n             [style.visibility]=\"currentTimeVisibility\"\n             [style.left]=\"currentTimeIndicatorPosition\"\n        ></div>\n      </div>\n\n    </div>\n  </div>\n</div>\n",
                styles: [".d-inline-block{display:inline-block!important}.text-center{text-align:center!important}.m-0{margin:0!important}.mb-1{margin-bottom:1rem!important}.btn{border:1px solid #e1e1e1;font-weight:600;text-decoration:none;color:#222;height:30px;padding:.5em 1em;cursor:pointer;margin:.2rem;border-radius:4px}.goto-modal{position:absolute;top:100%;left:0;height:auto;width:auto;border-radius:4px;background-color:#ddd;padding:5px;text-align:left;z-index:1}.time-sch-wrapper{overflow:auto}.time-sch-header-wrapper,.time-sch-table-wrapper,.time-sch-wrapper{position:relative}.time-sch-header-wrapper{padding:.5em;margin-bottom:.5em}.time-sch-table{width:100%;table-layout:fixed;border-collapse:collapse;border-spacing:0}.time-sch-period-container{float:left;position:relative}.time-sch-time-container{float:right;position:relative}.time-sch-wrapper .time-sch-section{width:200px}.time-sch-wrapper td,.time-sch-wrapper th{border-width:1px;border-style:solid;border-color:#e1e1e1 #c1c1c1}.time-sch-content-wrap{position:relative}.time-sch-section-wrapper{position:absolute;top:0;right:0;bottom:0;z-index:1;padding-left:1px;padding-right:1px}.time-sch-section-container{position:relative;overflow:hidden}.time-sch-item{position:absolute;min-height:1em;clear:both;background-color:#29d;color:#fff;border-radius:2px;cursor:pointer;transition:background-color .1s;border:1px solid #c1c1c1}.time-sch-item-content{overflow:hidden;white-space:nowrap;position:relative;z-index:1;padding:4px 0 4px 6px}.time-sch-item-end,.time-sch-item-start{position:absolute;top:2px;bottom:2px}.time-sch-item-start{left:1px;border-right:2px dotted #fff}.time-sch-item-end{right:1px;border-left:2px dotted #fff}.time-sch-current-time{position:absolute;top:0;bottom:0;z-index:2;background:0 0;border-left:1px dotted #000}.item-drag-placeholder{position:absolute;background:#ccc;border:3px dotted #999;transition:transform 250ms cubic-bezier(0,0,.2,1)}"]
            }] }
];
/** @nocollapse */
NgxTimeSchedulerComponent.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: NgxTimeSchedulerService }
];
NgxTimeSchedulerComponent.propDecorators = {
    SectionTd: [{ type: ViewChild, args: ['sectionTd', { static: false },] }],
    currentTimeFormat: [{ type: Input }],
    showCurrentTime: [{ type: Input }],
    showGoto: [{ type: Input }],
    showToday: [{ type: Input }],
    allowDragging: [{ type: Input }],
    showBusinessDayOnly: [{ type: Input }],
    headerFormat: [{ type: Input }],
    minRowHeight: [{ type: Input }],
    maxHeight: [{ type: Input }],
    text: [{ type: Input }],
    items: [{ type: Input }],
    sections: [{ type: Input }],
    periods: [{ type: Input }],
    events: [{ type: Input }],
    start: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.currentTimeFormat;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.showCurrentTime;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.showGoto;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.showToday;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.allowDragging;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.showBusinessDayOnly;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.headerFormat;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.minRowHeight;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.maxHeight;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.text;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.items;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.sections;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.periods;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.events;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.start;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.end;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.showGotoModal;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.currentTimeIndicatorPosition;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.currentTimeVisibility;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.currentTimeTitle;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.ShowCurrentTimeHandle;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.SectionLeftMeasure;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.currentPeriod;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.currentPeriodMinuteDiff;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.header;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.sectionItems;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.subscription;
    /** @type {?} */
    NgxTimeSchedulerComponent.prototype.showCurrentTimeIndicator;
    /**
     * @type {?}
     * @private
     */
    NgxTimeSchedulerComponent.prototype.changeDetector;
    /**
     * @type {?}
     * @private
     */
    NgxTimeSchedulerComponent.prototype.service;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxTimeSchedulerModule {
}
NgxTimeSchedulerModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxTimeSchedulerComponent],
                imports: [
                    CommonModule,
                    DragDropModule
                ],
                exports: [NgxTimeSchedulerComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Events, Header, HeaderDetails, Item, ItemMeta, NgxTimeSchedulerComponent, NgxTimeSchedulerModule, NgxTimeSchedulerService, Period, Section, SectionItem, Text };
//# sourceMappingURL=ngx-time-scheduler.js.map
