export declare class Period {
    name: string;
    classes: string;
    timeFramePeriod: number;
    timeFrameOverall: number;
    timeFrameHeaders: string[];
}
export declare class Item {
    id: number;
    name: string;
    start: any;
    end: any;
    classes: string;
    sectionID: number;
}
export declare class Section {
    id: number;
    name: string;
}
export declare class Text {
    NextButton: string;
    PrevButton: string;
    TodayButton: string;
    GotoButton: string;
    SectionTitle: string;
    constructor();
}
export declare class Events {
    ItemDropped: (item: Item) => void;
    ItemClicked: (item: Item) => void;
    ItemContextMenu: (item: Item, event: MouseEvent) => void;
    SectionClickEvent: (section: Section) => void;
    SectionContextMenuEvent: (section: Section, event: MouseEvent) => void;
}
export declare class SectionItem {
    section: Section;
    minRowHeight: number;
    itemMetas: ItemMeta[];
    constructor();
}
export declare class ItemMeta {
    item: Item;
    isStart: boolean;
    isEnd: boolean;
    cssTop: number;
    cssLeft: number;
    cssWidth: number;
    constructor();
}
export declare class Header {
    headerDetails: HeaderDetails[];
    constructor();
}
export declare class HeaderDetails {
    name: string;
    colspan: number;
}
